﻿Public Class Form1

    Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Integer, ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer
    'Private Declare Function ShowWindow Lib "user32" (ByVal hwnd As Integer, ByVal nCmdShow As Integer) As Integer
    Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Integer, ByRef lpRect As RECTANGLE) As Integer
    Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Integer
    'Private Declare Function FlashWindow Lib "user32" (ByVal hwnd As Integer, ByVal bInvert As Integer) As Integer

    'Const SWP_NOMOVE As Integer = &H2
    'Const SWP_NOSIZE As Integer = &H1
    'Const HWND_TOPMOST As Short = -1

    'Const SW_MAXIMIZE As Short = 3
    'Const SW_MINIMIZE As Short = 6
    'Const SW_RESTORE As Short = 9

    'Const FW_SWITCH As Integer = 1
    'Const FW_RESET As Integer = 0

    Const HWND_TOP As Integer = &H0

    'Const SW_SHOW As Integer = &H5
    'Const SW_HIDE As Integer = &H0
    Const SWP_SHOWWINDOW As Long = &H40
    Const SWP_NOACTIVATE As Long = &H10

    Private Structure RECTANGLE
        Dim Left As Integer
        Dim Top As Integer
        Dim Right As Integer
        Dim Bottom As Integer
    End Structure

    Dim hwnd, n As Integer
    Dim rect As RECTANGLE

    Private Sub btn_open_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_open.Click
        lst_log.Items.Clear()
        n = 0

        Timer1.Enabled = True
        dlg_open.Title = "Open File"
        Dim res As DialogResult = dlg_open.ShowDialog
        Timer1.Enabled = False

        My.Settings.TopLeft = New Drawing.Point(rect.Left, rect.Top)
        My.Settings.size = New Drawing.Size(rect.Right - rect.Left, rect.Bottom - rect.Top)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        'lst_log.Items.Add("Timer running at " & DateTime.Now.ToLongTimeString)
        'Dim r1, r2, r3 As Integer

        hwnd = FindWindow("#32770", dlg_open.Title) ' "#32770"

        If n = 0 Then
            'ShowWindow(hwnd, SW_HIDE)
            SetWindowPos(hwnd, HWND_TOP, My.Settings.TopLeft.X, My.Settings.TopLeft.Y, _
                          My.Settings.size.Width, My.Settings.size.Height, _
                          SWP_NOACTIVATE Or SWP_SHOWWINDOW)
            'ShowWindow(hwnd, SW_SHOW)
        Else
            GetWindowRect(hwnd, rect)

            lst_log.Items.Add(DateTime.Now.ToLongTimeString & Chr(9) & _
                              "Handle: " & hwnd.ToString & Chr(9) & _
                              "TopLeft: " & rect.Top & "/" & rect.Left & Chr(9) & _
                              "BottomRight: " & rect.Bottom & "/" & rect.Right)
        End If

        'r2 = SetWindowPos(XhWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE)
        'r3 = FlashWindow(XhWnd, FW_RESET)

        'lst_log.Items.Add("Results: " & r1 & Chr(9) & r2 & Chr(9) & r3)
        lst_log.TopIndex = lst_log.Items.Count - 1
        n += 1
    End Sub

End Class
